Subject: Re: bug#71847: Self-inflicted problem, libtool and automake installed to different prefixes

From: Dave Hart <[email-masked]>
Date: Fri, 5 Jul 2024 00:27:19 +0000

On Thu, 4 Jul 2024 at 22:27, Karl Berry <[email-masked]> wrote:

>     slow every bootstrap for us (which we do frequently) to work around a
>     relatively rare issue.
>
> Nick's solution of using acinclude.m4 seems ideal. But just in case: I
> think you could also avoid the extra libtoolize calls by doing them only
> if the automake --version is x.y.9*, i.e., a test release. Or, more
> directly, check for $automakeprefix>/share/aclocal*/libtool.m4 and only
> do the libtoolize if not already there.  I mean, where
>   automake_prefix=$(dirname $(which automake))/..
> Or something like that. You get the idea, I'm sure :).
>

While I agree I can avoid this problem with the acinclude.m4 approach, I'm
hesitant to do so because it's a corner case we don't hit that often, and
I'd rather put my effort into a general fix for everyone.

    But wouldn't it be better to make such a solution part of Automake
>     and have it gracefully handle this situation for everyone?
>
> Sure, clearly a graceful solution for everyone would be ideal. But in
> terms of the pending 1.17 release, I don't want to do something as
> potentially destabilizing as defining a stub LT_INIT in aclocal. That
> seems like it has great potential for confusion and problems.
>

Understood, I'm not trying to hold up 1.17.  I initially raised that
possibility because I didn't understand how corner-case it was.

> Also, looking at Automake/Variable.pm, there are a bunch of
> various/functions handled in the same way, e.g., CC vs. AC_PROG_CC
> just like LIBTOOL vs. LT_INIT. Although I think LT_INIT is the only one
> not defined by Automake or Autoconf.
>
> At any rate, It would also be nice to see an actual patch, since my
> knowledge of aclocal/automake<->libtool interaction is limited, at best,
> so I'm not sure offhand where or how to make such a change.
>

My perl skills are nearly zero, though I'm sure I can figure it out with
enough effort.  Perhaps raising the issue on the automake mailing list
would be productive in terms of soliciting suggestions on how to implement
this corner case improvement.

Meanwhile, I'll at least tweak the (test relese) NEWS and error message
> as you suggested. --thanks, karl.
>

Thank you.

-- 
Cheers,
Dave Hart